﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.Data;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    /// <summary>
    /// This converter is used to supply a value to the cell presenter based on the records information.
    /// </summary>
    public class UnboundFieldValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            // Determine what kind of value to show based on the data record.
            DataRecord drecord = parameter as DataRecord;

            //... Do logic on data record here.

            // Return calculated cell value.
            return drecord.Index;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }

    /// <summary>
    /// This converter is used to fix a first chance exception that may occur when the XamNumericEditor is supplied a string
    /// that contains letters.
    /// </summary>
    public class NumericEditorValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null)
                return value;

            double cellValue = 0;
            // The returned value can't be a string so try to convert it.
            if (value.GetType() == typeof(string))
            {
                if (double.TryParse((string)value, out cellValue))
                    return cellValue;

                // The text couldn't be parsed so return null.
                return null;
            }
            
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
